/******************************************************************************
 * DISCLAIMER
 * This software is supplied by Renesas Electronics Corporation and is only
 * intended for use with Renesas products. No other uses are authorized. This
 * software is owned by Renesas Electronics Corporation and is protected under
 * all applicable laws, including copyright laws.
 * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
 * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
 * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
 * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
 * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
 * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
 * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
 * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this
 * software and to discontinue the availability of this software. By using this
 * software, you agree to the additional terms and conditions found by
 * accessing the following link:
 * http://www.renesas.com/disclaimer
 *
 * Copyright (C) 2019 Renesas Electronics Corporation. All rights reserved.
 *****************************************************************************/
/*******************************************************************************
* File Name    : r_uart_lora.h
* Version      : 1.0
* Description  : UART driver for LoRaWANTM stack sample application.
******************************************************************************/
/*****************************************************************************
* History : DD.MM.YYYY Version  Description
*         : 31.05.2019 1.00     First Release
******************************************************************************/

#ifndef APP_UART_H
#define APP_UART_H

/*
UART state
*/
typedef enum app_uart_rx_state_s
{
    APP_UART_RX_IDLE,
    APP_UART_RX_RUNNING,
    APP_UART_RX_DONE,
    APP_UART_RX_ERROR,
    APP_UART_RX_OVERRUN
} app_uart_rx_state_t;

typedef enum app_uart_tx_state_s
{
    APP_UART_TX_IDLE,
    APP_UART_TX_RUNNING,
    APP_UART_TX_DONE,
    APP_UART_TX_ERROR,
} app_uart_tx_state_t;

/*
UART2
*/
//#define APP_UART2_RXBUF_SIZE   128
#define APP_UART2_RXBUF_SIZE   1
#define APP_UART2_TXBUF_SIZE   128

void app_uart2_init(void);
void app_uart2_deinit(void);
void app_uart2_send(char *);
void app_uart2_scan(char *);
void app_uart2_update_state(void);
void app_uart2_tx_done_callback(void);
void app_uart2_rx_done_callback(void);
void app_uart2_rx_error_callback(void);
void app_uart2_tx_error_callback(void);
void app_uart2_rx_overrun_callback(void);
bool app_uart2_can_sleep(void);

#endif // APP_UART_H
